This commit is contained in:
Phil Race 2016-04-05 09:13:52 -07:00
commit 82d451f3d7
4 changed files with 204 additions and 15 deletions

View File

@ -1,5 +1,5 @@
/*
* Copyright (c) 1994, 2010, Oracle and/or its affiliates. All rights reserved.
* Copyright (c) 1994, 2016, Oracle and/or its affiliates. All rights reserved.
* DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
*
* This code is free software; you can redistribute it and/or modify it
@ -299,6 +299,13 @@ public class FtpURLConnection extends URLConnection {
// Just keep throwing for now.
throw e;
} catch (FtpProtocolException fe) {
if (ftp != null) {
try {
ftp.close();
} catch (IOException ioe) {
fe.addSuppressed(ioe);
}
}
throw new IOException(fe);
}
try {
@ -481,11 +488,34 @@ public class FtpURLConnection extends URLConnection {
msgh.add("content-type", "text/plain");
msgh.add("access-type", "directory");
} catch (IOException ex) {
throw new FileNotFoundException(fullpath);
FileNotFoundException fnfe = new FileNotFoundException(fullpath);
if (ftp != null) {
try {
ftp.close();
} catch (IOException ioe) {
fnfe.addSuppressed(ioe);
}
}
throw fnfe;
} catch (FtpProtocolException ex2) {
throw new FileNotFoundException(fullpath);
FileNotFoundException fnfe = new FileNotFoundException(fullpath);
if (ftp != null) {
try {
ftp.close();
} catch (IOException ioe) {
fnfe.addSuppressed(ioe);
}
}
throw fnfe;
}
} catch (FtpProtocolException ftpe) {
if (ftp != null) {
try {
ftp.close();
} catch (IOException ioe) {
ftpe.addSuppressed(ioe);
}
}
throw new IOException(ftpe);
}
setProperties(msgh);

View File

@ -41,12 +41,13 @@ import java.util.stream.Collectors;
import java.util.stream.IntStream;
import java.util.stream.Stream;
import jdk.internal.org.objectweb.asm.ClassReader;
import jdk.tools.jlink.plugin.TransformerPlugin;
import jdk.tools.jlink.plugin.Pool;
import jdk.tools.jlink.plugin.PluginException;
import jdk.tools.jlink.internal.ResourcePrevisitor;
import jdk.tools.jlink.internal.StringTable;
import jdk.tools.jlink.internal.Utils;
import jdk.tools.jlink.plugin.PluginException;
import jdk.tools.jlink.plugin.Pool;
import jdk.tools.jlink.plugin.Pool.ModuleDataType;
import jdk.tools.jlink.plugin.TransformerPlugin;
/**
* Plugin to explicitly specify the locale data included in jdk.localedata
@ -84,8 +85,8 @@ public final class IncludeLocalesPlugin implements TransformerPlugin, ResourcePr
private static final String METAINFONAME = "LocaleDataMetaInfo";
private static final String META_FILES =
"*module-info.class," +
"*LocaleDataProvider*," +
"*" + METAINFONAME + "*,";
"*LocaleDataProvider.class," +
"*" + METAINFONAME + ".class,";
private static final String INCLUDE_LOCALE_FILES =
"*sun/text/resources/ext/[^\\/]+_%%.class," +
"*sun/util/resources/ext/[^\\/]+_%%.class," +
@ -116,7 +117,8 @@ public final class IncludeLocalesPlugin implements TransformerPlugin, ResourcePr
if (resource.getModule().equals(MODULENAME)) {
String path = resource.getPath();
resource = predicate.test(path) ? resource: null;
if (resource != null) {
if (resource != null &&
resource.getType().equals(ModuleDataType.CLASS_OR_RESOURCE)) {
byte[] bytes = resource.getBytes();
ClassReader cr = new ClassReader(bytes);
if (Arrays.stream(cr.getInterfaces())
@ -249,10 +251,10 @@ public final class IncludeLocalesPlugin implements TransformerPlugin, ResourcePr
files += INCLUDE_LOCALE_FILES.replaceAll("%%", isoSpecial + "_[0-9]{3}");
}
// Add Thai BreakIterator related files
// Add Thai BreakIterator related data files
if (lang.equals("th")) {
files += "*sun/text/resources/thai_dict," +
"*sun/text/resources/[^\\/]+_th,";
"*sun/text/resources/[^\\/]+BreakIteratorData_th,";
}
// Add Taiwan resource bundles for Hong Kong

View File

@ -1,6 +1,6 @@
#!/bin/sh
# Copyright (c) 2007, 2015, Oracle and/or its affiliates. All rights reserved.
# Copyright (c) 2007, 2016, Oracle and/or its affiliates. All rights reserved.
# DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
#
# This code is free software; you can redistribute it and/or modify it
@ -23,7 +23,7 @@
#
# @test
# @bug 6332666 6863624 7180362 8003846 8074350 8074351 8130246
# @bug 6332666 6863624 7180362 8003846 8074350 8074351 8130246 8149735
# @summary tests the capability of replacing the currency data with user
# specified currency properties file
# @build PropertiesTest
@ -85,12 +85,13 @@ PROPS=${TESTSRC}${FS}currency.properties
# Dump built-in currency data
run PropertiesTest -d dump1
if [ ! -f dump1 ]; then echo "file dump1 not created. Test cannot execute. Failed."; exit 1; fi
# Dump built-in currency data + overrides in properties file specified
# by system property.
run -Djava.util.currency.data=${PROPS} PropertiesTest -d dump2
if [ ! -f dump2 ]; then echo "file dump2 not created. Test cannot execute. Failed."; exit 1; fi
run PropertiesTest -c dump1 dump2 ${PROPS}
@ -102,7 +103,7 @@ run PropertiesTest -c dump1 dump2 ${PROPS}
WRITABLEJDK=.${FS}testjava
cp -H -R $TESTJAVA $WRITABLEJDK || exit 1
PROPLOCATION=${WRITABLEJDK}${FS}lib
chmod -R +w $WRITABLEJDK || exit 1
chmod -R a+rx $WRITABLEJDK || exit 1
cp ${PROPS} $PROPLOCATION || exit 1
echo "Properties location: ${PROPLOCATION}"
@ -110,6 +111,7 @@ echo "Properties location: ${PROPLOCATION}"
echo ''
${WRITABLEJDK}${FS}bin${FS}java ${TESTVMOPTS} -cp ${TESTCLASSES} PropertiesTest -d dump3
if [ $? != 0 ]; then failures=`expr $failures + 1`; fi
if [ ! -f dump3 ]; then echo "file dump3 not created. Test cannot execute. Failed."; exit 1; fi
# Cleanup
rm -rf $WRITABLEJDK

View File

@ -0,0 +1,155 @@
/*
* Copyright (c) 2016, Oracle and/or its affiliates. All rights reserved.
* DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
*
* This code is free software; you can redistribute it and/or modify it
* under the terms of the GNU General Public License version 2 only, as
* published by the Free Software Foundation.
*
* This code is distributed in the hope that it will be useful, but WITHOUT
* ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
* FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
* version 2 for more details (a copy is included in the LICENSE file that
* accompanied this code).
*
* You should have received a copy of the GNU General Public License version
* 2 along with this work; if not, write to the Free Software Foundation,
* Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
*
* Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
* or visit www.oracle.com if you need additional information or have any
* questions.
*/
/*
* @test
* @bug 7167293
* @summary FtpURLConnection doesn't close FTP connection when FileNotFoundException is thrown
* @library ../www/ftptest/
* @build FtpServer FtpCommandHandler FtpAuthHandler FtpFileSystemHandler
* @run main FtpURLConnectionLeak
*/
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.URL;
public class FtpURLConnectionLeak {
public static void main(String[] args) throws Exception {
FtpServer server = new FtpServer(0);
server.setFileSystemHandler(new CustomFileSystemHandler("/"));
server.setAuthHandler(new MyAuthHandler());
int port = server.getLocalPort();
server.start();
URL url = new URL("ftp://localhost:" + port + "/filedoesNotExist.txt");
for (int i = 0; i < 3; i++) {
try {
InputStream stream = url.openStream();
} catch (FileNotFoundException expectedFirstTimeAround) {
// should always reach this point since the path does not exist
} catch (IOException expected) {
System.out.println("caught expected " + expected);
int times = 1;
do {
// give some time to close the connection...
System.out.println("sleeping... " + times);
Thread.sleep(times * 1000);
} while (server.activeClientsCount() > 0 && times++ < 5);
if (server.activeClientsCount() > 0) {
server.killClients();
throw new RuntimeException("URLConnection didn't close the" +
" FTP connection on FileNotFoundException");
}
} finally {
server.terminate();
}
}
}
static class CustomFileSystemHandler implements FtpFileSystemHandler {
private String currentDir;
public CustomFileSystemHandler(String path) {
currentDir = path;
}
@Override
public boolean cd(String path) {
currentDir = path;
return true;
}
@Override
public boolean cdUp() {
throw new UnsupportedOperationException("Not supported yet.");
}
@Override
public String pwd() {
throw new UnsupportedOperationException("Not supported yet.");
}
@Override
public boolean fileExists(String name) {
throw new UnsupportedOperationException("Not supported yet.");
}
@Override
public InputStream getFile(String name) {
return null; //return null so that server will return 550 File not found.
}
@Override
public long getFileSize(String name) {
throw new UnsupportedOperationException("Not supported yet.");
}
@Override
public InputStream listCurrentDir() {
return null;
}
@Override
public OutputStream putFile(String name) {
throw new UnsupportedOperationException("Not supported yet.");
}
@Override
public boolean removeFile(String name) {
throw new UnsupportedOperationException("Not supported yet.");
}
@Override
public boolean mkdir(String name) {
throw new UnsupportedOperationException("Not supported yet.");
}
@Override
public boolean rename(String from, String to) {
throw new UnsupportedOperationException("Not supported yet.");
}
}
static class MyAuthHandler implements FtpAuthHandler {
@Override
public int authType() {
return 0;
}
@Override
public boolean authenticate(String user, String password) {
return true;
}
@Override
public boolean authenticate(String user, String password, String account) {
return true;
}
}
}